' modified 31 December 2005 by Erik Siers for EEShell
' removed everything except the open dialog

'------------------------------------------------------------------------------
'
'  COMDLG32.INC -- Windows API Common Dialog declarations for PowerBASIC
'
'  Copyright (C) 1997-2002 PowerBASIC, Inc.
'  Portions Copyright (C) 1992-1999 Microsoft Corporation
'  All Rights Reserved.
'
'  Last Update: 11 March 2003
'
'  This file is not compatible with Visual Basic.  It uses the correct
'  data type as defined in the Microsoft SDK for Windows for all API calls.
'  This includes data types which are not natively supported in Visual Basic
'  such as unsigned integers and ASCIIZ strings.
'
'  You have a royalty-free right to use, modify, reproduce and distribute
'  this file (and/or any modified version) in any way you find useful,
'  provided that you agree that both PowerBASIC and Microsoft have no
'  warranty, obligation or liability for its contents.
'
'------------------------------------------------------------------------------

%COMDLG32_INC = 1


' Common dialog error codes

%CDERR_DIALOGFAILURE            = &HFFFF
%CDERR_GENERALCODES             = &H0000
%CDERR_STRUCTSIZE               = &H0001
%CDERR_INITIALIZATION           = &H0002
%CDERR_NOTEMPLATE               = &H0003
%CDERR_NOHINSTANCE              = &H0004
%CDERR_LOADSTRFAILURE           = &H0005
%CDERR_FINDRESFAILURE           = &H0006
%CDERR_LOADRESFAILURE           = &H0007
%CDERR_LOCKRESFAILURE           = &H0008
%CDERR_MEMALLOCFAILURE          = &H0009
%CDERR_MEMLOCKFAILURE           = &H000A
%CDERR_NOHOOK                   = &H000B
%CDERR_REGISTERMSGFAIL          = &H000C

DECLARE FUNCTION CommDlgExtendedError LIB "COMDLG32.DLL" ALIAS "CommDlgExtendedError" () AS DWORD


'-----------------------------------------------------------------------------
' Filename common dialogs

%OFN_READONLY             = &H00000001
%OFN_OVERWRITEPROMPT      = &H00000002
%OFN_HIDEREADONLY         = &H00000004
%OFN_NOCHANGEDIR          = &H00000008
%OFN_SHOWHELP             = &H00000010
%OFN_ENABLEHOOK           = &H00000020
%OFN_ENABLETEMPLATE       = &H00000040
%OFN_ENABLETEMPLATEHANDLE = &H00000080
%OFN_NOVALIDATE           = &H00000100
%OFN_ALLOWMULTISELECT     = &H00000200
%OFN_EXTENSIONDIFFERENT   = &H00000400
%OFN_PATHMUSTEXIST        = &H00000800
%OFN_FILEMUSTEXIST        = &H00001000
%OFN_CREATEPROMPT         = &H00002000
%OFN_SHAREAWARE           = &H00004000
%OFN_NOREADONLYRETURN     = &H00008000
%OFN_NOTESTFILECREATE     = &H00010000
%OFN_NONETWORKBUTTON      = &H00020000
%OFN_NOLONGNAMES          = &H00040000 ' force no long names for 4.x modules
%OFN_EXPLORER             = &H00080000 ' new look commdlg
%OFN_NODEREFERENCELINKS   = &H00100000
%OFN_LONGNAMES            = &H00200000 ' force long names for 3.x modules
%OFN_ENABLEINCLUDENOTIFY  = &H00400000 ' send include message to callback
%OFN_ENABLESIZING         = &H00800000
%OFN_DONTADDTORECENT      = &H02000000
%OFN_FORCESHOWHIDDEN      = &H10000000 ' Show All files including System and hidden files

%OFN_EX_NOPLACESBAR       = &H00000001

' Return values for the registered message sent to the hook function
' when a sharing violation occurs.  %OFN_SHAREFALLTHROUGH allows the
' filename to be accepted, %OFN_SHARENOWARN rejects the name but puts
' up no warning (returned when the app has already put up a warning
' message), and %OFN_SHAREWARN puts up the default warning message
' for sharing violations.
'
' Note:  Undefined return values map to OFN_SHAREWARN, but are
'        reserved for future use.

%OFN_SHAREFALLTHROUGH     = 2
%OFN_SHARENOWARN          = 1
%OFN_SHAREWARN            = 0

#IF NOT %DEF(%CDN_FIRST)
%CDN_FIRST               = 0-601       ' common dialog new
#ENDIF
#IF NOT %DEF(%CDN_LAST)
%CDN_LAST                = 0-699
#ENDIF

' Notifications from Open or Save dialog
%CDN_INITDONE         = %CDN_FIRST - &H0000
%CDN_SELCHANGE        = %CDN_FIRST - &H0001
%CDN_FOLDERCHANGE     = %CDN_FIRST - &H0002
%CDN_SHAREVIOLATION   = %CDN_FIRST - &H0003
%CDN_HELP             = %CDN_FIRST - &H0004
%CDN_FILEOK           = %CDN_FIRST - &H0005
%CDN_TYPECHANGE       = %CDN_FIRST - &H0006
%CDN_INCLUDEITEM      = %CDN_FIRST - &H0007

%FNERR_FILENAMECODES      = &H3000
%FNERR_SUBCLASSFAILURE    = &H3001
%FNERR_INVALIDFILENAME    = &H3002
%FNERR_BUFFERTOOSMALL     = &H3003

TYPE OPENFILENAME
    lStructSize       AS DWORD
    hWndOwner         AS DWORD
    hInstance         AS DWORD
    lpstrFilter       AS ASCIIZ PTR
    lpstrCustomFilter AS ASCIIZ PTR
    nMaxCustFilter    AS DWORD
    nFilterIndex      AS DWORD
    lpstrFile         AS ASCIIZ PTR
    nMaxFile          AS DWORD
    lpstrFileTitle    AS ASCIIZ PTR
    nMaxFileTitle     AS DWORD
    lpstrInitialDir   AS ASCIIZ PTR
    lpstrTitle        AS ASCIIZ PTR
    Flags             AS DWORD
    nFileOffset       AS WORD
    nFileExtension    AS WORD
    lpstrDefExt       AS ASCIIZ PTR
    lCustData         AS LONG
    lpfnHook          AS DWORD
    lpTemplateName    AS ASCIIZ PTR
END TYPE

TYPE NMHDR
  hwndFrom AS DWORD
  idfrom AS DWORD
  code AS LONG    ' used for messages, so needs to be LONG, not DWORD...
END TYPE

TYPE OFNOTIFY
    hdr     AS NMHDR
    lpOFN   AS OPENFILENAME PTR
    pszFile AS ASCIIZ PTR
END TYPE

DECLARE FUNCTION GetOpenFileName LIB "COMDLG32.DLL" ALIAS "GetOpenFileNameA" _
    (lpofn AS OPENFILENAME) AS LONG

#IF NOT %DEF(%OFN_FILEBUFFERSIZE)
    ' Max bytes to allow for returning the selected file or list of files.
    ' This must be at least equal to %MAX_PATH for safety.
    %OFN_FILEBUFFERSIZE = 8192
#ENDIF

FUNCTION OpenFileDialog (BYVAL hWnd AS DWORD, _            ' parent window
                         BYVAL sCaption AS STRING, _       ' caption
                         sFileSpec AS STRING, _            ' filename
                         BYVAL sInitialDir AS STRING, _    ' start directory
                         BYVAL sFilter AS STRING, _        ' filename filter
                         BYVAL sDefExtension AS STRING, _  ' default extension
                         dFlags AS DWORD _                 ' flags
                        ) AS LONG

    LOCAL ix          AS LONG
    LOCAL ofn         AS OPENFILENAME
    LOCAL szFileTitle AS ASCIIZ * %MAX_PATH

    ' Filter is a sequence of ASCIIZ strings with a final (extra) $NUL terminator
    REPLACE "|" WITH $NUL IN sFilter
    sFilter = sFilter + $NUL

    IF LEN(sInitialDir) = 0 THEN
        sInitialDir = CURDIR$
    END IF

    ix = INSTR(sFileSpec, $NUL)
    IF ix THEN
        sFileSpec = LEFT$(sFileSpec, ix) + SPACE$(%OFN_FILEBUFFERSIZE - ix)
    ELSE
        sFileSpec = sFileSpec + $NUL + SPACE$(%OFN_FILEBUFFERSIZE - (LEN(sFileSpec) + 1))
    END IF

    ofn.lStructSize      = SIZEOF(ofn)
    ofn.hWndOwner        = hWnd
    ofn.lpstrFilter      = STRPTR(sFilter)
    ofn.nFilterIndex     = 1
    ofn.lpstrFile        = STRPTR(sFileSpec)
    ofn.nMaxFile         = LEN(sFileSpec)
    ofn.lpstrFileTitle   = VARPTR(szFileTitle)
    ofn.nMaxFileTitle    = SIZEOF(szFileTitle)
    ofn.lpstrInitialDir  = STRPTR(sInitialDir)
    IF LEN(sCaption) THEN
        ofn.lpstrTitle   = STRPTR(sCaption)
    END IF
    ofn.Flags            = dFlags
    IF LEN(sDefExtension) THEN
        ofn.lpstrDefExt  = STRPTR(sDefExtension)
    END IF

    FUNCTION = GetOpenFilename(ofn)

    ix = INSTR(-1, sFileSpec, $NUL)
    IF ix THEN
        sFileSpec = LEFT$(sFileSpec, ix - 1)
    ELSE
        sFileSpec = ""
    END IF

    dFlags = ofn.Flags
END FUNCTION
