#PBFORMS CREATED V1.51

' EEShell 1.1.3 - main file
' copyright 2005-2008 Erik Siers
' source available under terms of the GNU GPL

#COMPILE EXE
#DIM ALL
#OPTION VERSION3
#TOOLS OFF
#DEBUG ERROR OFF

'------------------------------
'   ** Includes **
'------------------------------
#PBFORMS BEGIN INCLUDES
#RESOURCE "EEShell.pbr"
#INCLUDE "Win32API.bi"  ' trimmed way the hell down for EEShell - the standard Win32API.inc will also work but
                        ' will increase the final .exe size by 3.5 KB
#PBFORMS END INCLUDES
'------------------------------

#INCLUDE "ComDlg32.bi"  ' trimmed down for EEShell - the standard ComDlg32.inc will also work but that requires
                        ' the standard Win32API.inc instead of my trimmed-down version, and results in a total
                        ' increase in the size of the final .exe of 5 KB
#INCLUDE "Log.bi"
#INCLUDE "Run.bi"
#INCLUDE "AppPathName.bi"
#INCLUDE "Startup.bi"
#INCLUDE "Shutdown.bi"

'------------------------------
'   ** Constants **
'------------------------------
#PBFORMS BEGIN CONSTANTS
%IDD_DIALOG_MAIN     =  101
%IDC_BUTTON_EXIT     = 1001
%IDC_BUTTON_LOGOFF   = 1002
%IDC_BUTTON_SHUTDOWN = 1003
%IDC_BUTTON_RESTART  = 1004
%IDC_BUTTON_STANDBY  = 1005
%IDC_BUTTON_RUN      = 1006
#PBFORMS END CONSTANTS
'------------------------------

'------------------------------
'   ** Declarations **
'------------------------------
GLOBAL hDlg AS DWORD

DECLARE CALLBACK FUNCTION ShowDIALOG_MAINProc()
DECLARE FUNCTION ShowDIALOG_MAIN(BYVAL hParent AS DWORD) AS LONG
#PBFORMS DECLARATIONS
'------------------------------

'------------------------------
'   ** Main Application Entry Point **
'------------------------------
FUNCTION PBMAIN()
    runStartup
    ShowDIALOG_MAIN 0???
END FUNCTION
'------------------------------

'------------------------------
'   ** CallBacks **
'------------------------------
CALLBACK FUNCTION ShowDIALOG_MAINProc()
    LOCAL tmpLng AS LONG

    SELECT CASE AS LONG CBMSG
        CASE %WM_INITDIALOG
            ' Initialization handler
        CASE %WM_NCACTIVATE
            STATIC hWndSaveFocus AS DWORD
            IF ISFALSE CBWPARAM THEN
                ' Save control focus
                hWndSaveFocus = GetFocus()
            ELSEIF hWndSaveFocus THEN
                ' Restore control focus
                SetFocus(hWndSaveFocus)
                hWndSaveFocus = 0
            END IF
        CASE %WM_COMMAND
            ' Process control notifications
            SELECT CASE AS LONG CBCTL
                CASE %IDC_BUTTON_EXIT
                    IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
                        DIALOG END CBHNDL
                    END IF
                CASE %IDC_BUTTON_LOGOFF
                    IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
                        tmpLng = MSGBOX("Logoff?", %MB_YESNO OR %MB_ICONQUESTION OR %MB_TASKMODAL, "Logoff?")
                        IF %IDYES = tmpLng THEN
                            IF quitWindows (%EWX_LOGOFF) THEN DIALOG END CBHNDL
                        END IF
                    END IF
                CASE %IDC_BUTTON_SHUTDOWN
                    IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
                        tmpLng = MSGBOX("Shut the computer down?", %MB_YESNO OR %MB_ICONQUESTION OR %MB_TASKMODAL, "Shutdown?")
                        IF %IDYES = tmpLng THEN
                            IF quitWindows (%EWX_SHUTDOWN) THEN DIALOG END CBHNDL
                        END IF
                    END IF
                CASE %IDC_BUTTON_RESTART
                    IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
                        tmpLng = MSGBOX("Restart the computer?", %MB_YESNO OR %MB_ICONQUESTION OR %MB_TASKMODAL, "Restart?")
                        IF %IDYES = tmpLng THEN
                            IF quitWindows (%EWX_REBOOT) THEN DIALOG END CBHNDL
                        END IF
                    END IF
                CASE %IDC_BUTTON_STANDBY
                    IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
                        tmpLng = MSGBOX("Go to standby?", %MB_YESNO OR %MB_ICONQUESTION OR %MB_TASKMODAL, "Standby?")
                        IF %IDYES = tmpLng THEN StandBy
                    END IF
                CASE %IDC_BUTTON_RUN
                    IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
                        LOCAL Caption AS STRING, File AS STRING, StartDir AS STRING, Filter AS STRING
                        LOCAL dExt AS STRING, Flags AS DWORD
                        Caption = "Run..."
                        File = ""
                        StartDir = ""
                        Filter = "Programs|*.com;*.eXe|Batch files|*.bat;*.cmd|Scripts|*.js*;*.vb*|" & _
                                "Control panel applets|*.cpl|Common document formats|" & _
                                "*.doc;*.htm*;*.pdf;*.rtf;*.tXt;*.Xls|Common image formats|*.bmp;*.gif;*.jp*;*.png|" & _
                                "All Files|*.*"
                        dExt = ""
                        Flags = %OFN_HIDEREADONLY OR %OFN_FILEMUSTEXIST
                        ' hDlg is our hwnd
                        IF OpenFileDialog(hDlg, Caption, File, StartDir, Filter, dExt, Flags) THEN Run File
                    END IF
            END SELECT
    END SELECT
END FUNCTION
'------------------------------

'------------------------------
'   ** Dialogs **
'------------------------------
FUNCTION ShowDIALOG_MAIN(BYVAL hParent AS DWORD) AS LONG
    LOCAL lRslt AS LONG

#PBFORMS BEGIN DIALOG %IDD_DIALOG_MAIN->->
    LOCAL hDlg  AS DWORD

    DIALOG NEW hParent, "EEShell", 70, 70, 117, 92, %WS_POPUP OR %WS_BORDER OR %WS_DLGFRAME OR %WS_CAPTION OR _
            %WS_MINIMIZEBOX OR %WS_CLIPSIBLINGS OR %WS_VISIBLE OR %DS_ABSALIGN OR %DS_MODALFRAME OR %DS_SETFOREGROUND _
            OR %DS_CENTER OR %DS_CENTERMOUSE OR %DS_3DLOOK OR %DS_NOFAILCREATE OR %DS_SETFONT, %WS_EX_APPWINDOW OR _
            %WS_EX_LEFT OR %WS_EX_LTRREADING OR %WS_EX_RIGHTSCROLLBAR, TO hDlg
    CONTROL ADD BUTTON, hDlg, %IDC_BUTTON_RUN, "Run", 65, 5, 50, 15, %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP OR _
            %BS_TEXT OR %BS_DEFPUSHBUTTON OR %BS_PUSHBUTTON OR %BS_CENTER OR %BS_VCENTER, %WS_EX_LEFT OR _
            %WS_EX_LTRREADING
    DIALOG  SEND        hDlg, %DM_SETDEFID, %IDC_BUTTON_RUN, 0
    CONTROL ADD BUTTON, hDlg, %IDC_BUTTON_EXIT, "Exit", 5, 5, 50, 15
    CONTROL ADD BUTTON, hDlg, %IDC_BUTTON_LOGOFF, "Logoff", 5, 30, 50, 15
    CONTROL ADD BUTTON, hDlg, %IDC_BUTTON_SHUTDOWN, "Shutdown", 5, 45, 50, 15
    CONTROL ADD BUTTON, hDlg, %IDC_BUTTON_RESTART, "Restart", 5, 60, 50, 15
    CONTROL ADD BUTTON, hDlg, %IDC_BUTTON_STANDBY, "Standby", 5, 75, 50, 15
#PBFORMS END DIALOG
    DIALOG SHOW MODAL hDlg, CALL ShowDIALOG_MAINProc TO lRslt
#PBFORMS BEGIN CLEANUP %IDD_DIALOG_MAIN
#PBFORMS END CLEANUP
    FUNCTION = lRslt
END FUNCTION
'------------------------------
