' EEShell 1.1.2 - logging and NT detection
' from EEShell2
' copyright 2004-2006 Erik Siers
' source available under terms of the GNU GPL version 3

FUNCTION appLog ALIAS "appLog" (item AS STRING, callingFunction AS STRING) AS LONG
    ' writes an event to the app's log
    ' I don't want to use the system logging APIs so I wrote my own

    ' args:
    ' item              the event to log
    ' callingFunction   the function which is logging the event - if you don't want this, pass an empty string -> ""

    ' returns:
    ' 0         item succesfully logged
    ' non-zero  PB error # (note that this is not necessarily the same as VB error #s)

    ' usage (from VB):
    '       x& = appLog ("event to log", "Form_Click")
    '      IF x& THEN MSGBOX "Error logging!"

    ON ERROR GOTO finish

    LOCAL logNum AS LONG, outP AS STRING, logFile AS STRING

    outP = DATE$ & " " & TIME$ & ": " & IIF$(LEN(callingFunction) > 0, callingFunction & ": ", "") & item
    logFile = "EEShell.log"
    logNum = FREEFILE

    OPEN logFile FOR APPEND AS logNum
        PRINT #logNum, outP

finish:
    CLOSE
    FUNCTION = ERRCLEAR
END FUNCTION

FUNCTION IsWinNT ALIAS "IsWinNT" () AS LONG
    ' Detect if the program is running under Windows NT
    LOCAL myOS AS OSVERSIONINFO

    myOS.dwOSVersionInfoSize = SIZEOF(myOS)
    GetVersionEx myOS
    FUNCTION = (%VER_PLATFORM_WIN32_NT = myOS.dwPlatformId)
END FUNCTION
