' EEShell 1.1.2 - the "run" module
' from EEShell2
' copyright 2004-2006 Erik Siers
' source available under terms of the GNU GPL version 3

FUNCTION resEnv(pPath AS STRING) AS STRING
    ' recursive function
    ' pPath begins with env.var, need to find first %, chop, rinse, repeat
    REGISTER p AS LONG, p2 AS LONG
    LOCAL e AS STRING, o AS STRING

    p = INSTR(pPath, "%")
    IF p THEN
        e = LEFT$(pPath, p - 1)
        p2 = INSTR(p + 1, pPath, "%")
        IF p2 THEN
            resEnv = ENVIRON$(e) & MID$(pPath, p + 1, p2 - p - 1) & resEnv(MID$(pPath, p2 + 1))
        ELSE
            resEnv = ENVIRON$(e) & MID$(pPath, p + 1)
        END IF
    ELSE
        resEnv = pPath
    END IF
END FUNCTION

FUNCTION Run (runItem AS STRING) AS LONG
    ' wrapper for ShellExecute API

    ' args:
    ' runItem   app or doc to be loaded (%environment_variables% okay, I think)

    ' returns:
    ' 0         no error
    ' 2 or 53   file not found
    ' 64        bad file name (runItem was possibly too long)
    ' else      possible DLL error

    ' *****to do: allow searching of %path%
    ' right now, runItem must be the full path to whatever is being started
    ON ERROR GOTO ohCrapRun
    REGISTER sE AS LONG
    IF LEN(runItem) > 255 THEN ERROR 64
    LOCAL runMe AS ASCIIZ * 255

    ' resolve environment variables
    sE = INSTR(runItem, "%")
    IF sE > 0 THEN runItem = LEFT$(runItem, sE - 1) & resEnv(MID$(runItem, sE + 1))
    runMe = runItem

    sE = ShellExecute(0, "", runMe, "", "", 5)
    IF 2 = sE THEN
        sE = appLog(runItem & ": File not found.", FUNCNAME$)
    ELSE
        sE = appLog(runItem & ": File not found.", FUNCNAME$)
    END IF
    FUNCTION = sE
    EXIT FUNCTION

ohCrapRun:
    REGISTER eee AS LONG
    eee = ERRCLEAR
    sE = appLog("Error #" & TRIM$(STR$(eee)) & " running " & runItem, FUNCNAME$)
    FUNCTION = eee OR sE
END FUNCTION
